Index: app_voicemail.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_voicemail.c,v
retrieving revision 1.138
diff -u -r1.138 app_voicemail.c
--- app_voicemail.c	16 Aug 2004 04:05:43 -0000	1.138
+++ app_voicemail.c	27 Aug 2004 21:27:33 -0000
@@ -3510,6 +3510,8 @@
 	struct ast_vm_user *vmu = NULL, vmus;
 	char *context=NULL;
 	int silentexit = 0;
+	char *callerid, *name;
+	char cid[256]="";
 
 	LOCAL_USER_ADD(u);
 	memset(&vms, 0, sizeof(vms));
@@ -3569,10 +3571,20 @@
 			goto out;
 		}
 		if (ast_strlen_zero(vms.username)) {
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "Username not entered\n");
-			res = 0;
-			goto out;
+				if(chan->callerid != NULL) {
+				strncpy(cid, chan->callerid, sizeof(cid) - 1);
+				ast_callerid_parse(cid, &name, &callerid);
+				}
+				if(callerid != NULL) {			
+					if (option_verbose > 2)
+					ast_verbose(VERBOSE_PREFIX_3 "No username but # key pressed. Using CID '%s'\n",callerid);
+					strncpy(vms.username, callerid, sizeof(vms.username) - 1);
+				} else {
+					if (option_verbose > 2)
+					ast_verbose(VERBOSE_PREFIX_3 "Username not entered\n");	
+					res = 0;
+					goto out;
+				}
 		}
 		if (useadsi)
 			adsi_password(chan);
